# Interface MonitorWaitedRequest

All Superinterfaces:
  `EventRequest, Mirror`

public interface MonitorWaitedRequest extends EventRequest
Request for notification when a thread in the target VM has finished waiting on a monitor object. That is, a thread is leaving Object.wait(). " When an enabled MonitorWaitedRequest is satisfied, an `event set` containing a `MonitorWaitedEvent` will be placed on the `EventQueue`. The collection of existing MonitorWaitedEvents is managed by the `EventRequestManager`

Since:
  1.6
See Also:
  - `MonitorWaitedEvent`
  - `EventQueue`
  - `EventRequestManager`

## Field Summary

### Fields declared in interface EventRequest

`SUSPEND_ALL, SUSPEND_EVENT_THREAD, SUSPEND_NONE`
Modifier and Type
Field
Description
`static final int`
`SUSPEND_ALL`
Suspend all threads when the event occurs
`static final int`
`SUSPEND_EVENT_THREAD`
Suspend only the thread which generated the event when the event occurs
`static final int`
`SUSPEND_NONE`
Suspend no threads when the event occurs

## Method Summary

Modifier and Type
Method
Description
`void`
`addClassExclusionFilter(String classPattern)`
Restricts the events generated by this request to those in which the name of the class of the monitor object does notmatch this restricted regular expression, e.g.
`void`
`addClassFilter(ReferenceType refType)`
Restricts the events generated by this request to those whose monitor object is of the given reference type or any of its subtypes.
`void`
`addClassFilter(String classPattern)`
Restricts the events generated by this request to those in which the name of the class of the monitor object matches this restricted regular expression.
`void`
`addInstanceFilter(ObjectReference instance)`
Restricts the events generated by this request to those in which the currently executing instance ("this") is the object specified.
`void`
`addThreadFilter(ThreadReference thread)`
Restricts the events generated by this request to those in the given thread.

### Methods declared in interface EventRequest

`addCountFilter, disable, enable, getProperty, isEnabled, putProperty, setEnabled, setSuspendPolicy, suspendPolicy`
Modifier and Type
Method
Description
`void`
`addCountFilter(int count)`
Limit the requested event to be reported at most once after a given number of occurrences.
`void`
`disable()`
Same as `setEnabled(false)`.
`void`
`enable()`
Same as `setEnabled(true)`.
`Object`
`getProperty(Object key)`
Returns the value of the property with the specified key.
`boolean`
`isEnabled()`
Determines if this event request is currently enabled.
`void`
`putProperty(Object key, Object value)`
Add an arbitrary key/value "property" to this request.
`void`
`setEnabled(boolean val)`
Enables or disables this event request.
`void`
`setSuspendPolicy(int policy)`
Determines the threads to suspend when the requested event occurs in the target VM.
`int`
`suspendPolicy()`
Returns a value which describes the threads to suspend when the requested event occurs in the target VM.

### Methods declared in interface Mirror

`toString, virtualMachine`
Modifier and Type
Method
Description
`String`
`toString()`
Returns a String describing this mirror
`VirtualMachine`
`virtualMachine()`
Gets the VirtualMachine to which this Mirror belongs.

## Method Details

### addThreadFilter

void addThreadFilter(ThreadReference thread)
Restricts the events generated by this request to those in the given thread.

Parameters:
  `thread` - the thread to filter on.
Throws:
  `InvalidRequestStateException` - if this request is currently enabled or has been deleted. Filters may be added only to disabled requests.

### addClassFilter

void addClassFilter(ReferenceType refType)
Restricts the events generated by this request to those whose monitor object is of the given reference type or any of its subtypes.

Parameters:
  `refType` - the reference type to filter on.
Throws:
  `InvalidRequestStateException` - if this request is currently enabled or has been deleted. Filters may be added only to disabled requests.

### addClassFilter

void addClassFilter(String classPattern)
Restricts the events generated by this request to those in which the name of the class of the monitor object matches this restricted regular expression. Regular expressions are limited to exact matches and patterns that begin with '*' or end with '*'; for example, "*.Foo" or "java.*".

Parameters:
  `classPattern` - the pattern String to filter for.
Throws:
  `InvalidRequestStateException` - if this request is currently enabled or has been deleted. Filters may be added only to disabled requests.

### addClassExclusionFilter

void addClassExclusionFilter(String classPattern)
Restricts the events generated by this request to those in which the name of the class of the monitor object does notmatch this restricted regular expression, e.g. "java.*" or "*.Foo".

Parameters:
  `classPattern` - the pattern String to filter against.
Throws:
  `InvalidRequestStateException` - if this request is currently enabled or has been deleted. Filters may be added only to disabled requests.

### addInstanceFilter

void addInstanceFilter(ObjectReference instance)
Restricts the events generated by this request to those in which the currently executing instance ("this") is the object specified.

Not all targets support this operation. Use `VirtualMachine.canUseInstanceFilters()` to determine if the operation is supported.

Parameters:
  `instance` - the object which must be the current instance in order to pass this filter.
Throws:
  `UnsupportedOperationException` - if the target virtual machine does not support this operation.
  `InvalidRequestStateException` - if this request is currently enabled or has been deleted. Filters may be added only to disabled requests.